package com.pixelized.server.lwa.server.rest.inventory

import com.pixelized.server.lwa.server.Engine
import com.pixelized.server.lwa.utils.extentions.characterSheetId
import com.pixelized.server.lwa.utils.extentions.exception
import com.pixelized.shared.lwa.protocol.rest.APIResponse
import io.ktor.server.response.respond
import io.ktor.server.routing.RoutingContext

fun Engine.getInventory(): suspend RoutingContext.() -> Unit {
    return {
        try {
            // get the query parameter
            val characterSheetId = call.queryParameters.characterSheetId
            // get the character inventory
            val inventory = inventoryService.inventoryJson(
                characterSheetId = characterSheetId,
            )
            // send it back to the user.
            call.respond(
                message = APIResponse.success(
                    data = inventory
                )
            )
        } catch (exception: Exception) {
            call.exception(
                exception = exception
            )
        }
    }
}